/*
** echoStruct web service handler.
*/
value = soapParameterGet($soap, "echoStruct");
if (!isStruct(value))
{
	soapResultError($soap, "ignore", "echoStruct not passed a struct");
}
else if ((value.varInt != 3) ||
	 (value.varFloat != 1.2) ||
	 (value.varString != "Hello"))
{
	soapResultError($soap, "ignore", "echoStruct passed unexpected values");
}
else
{
	soapResultAdd($soap, NULL, value);
}
