<% 
#include "check.asp" 

root = findParameter($params, "root", "false");
if ((root == "true") && (!isSambarAdmin($request)))
	exit;

vcards = NULL;
try
{
	if (root == "true")
	{
		vcards = vcardOpen("maildir");
	}
	else
	{
		if (!vcardExists(vcf))
			addrbookImport(vcf);

		vcards = vcardOpen(vcf);
	}
}
catch (e)
{
    write("<!--\n");
    write(exception(e, "info"));
    write("\n-->\n");
    exit;
}

action = getParameter($params, "action");
guid = getParameter($params, "guid");
if ((vcards != null) && (action == "add"))
{
	nick = getParameter($params, "nickname");
	fname = getParameter($params, "firstname");
	mname = getParameter($params, "middlename");
	lname = getParameter($params, "lastname");
	email1 = getParameter($params, "email1");
	email2 = getParameter($params, "email2");
	if ((sizeof(nick) > 0) || (sizeof(fname) > 0) || (sizeof(lname) > 0) ||
		(sizeof(email1) > 0) || (sizeof(email2) > 0))
	{
		if (sizeof(guid) > 0)
			vcard = vcardGet(vcards, guid);
		else
			vcard = vcardAdd(vcards);

		if (sizeof(nick) == 0)
		{
			if (sizeof(fname) > 0)
				nick = fname;
			if (sizeof(lname) > 0)
				nick = nick + " " + lname;
		}

		if (sizeof(nick) == 0)
		{
			if (sizeof(email1) > 0)
				nick = email1;
			else
				nick = email2;
		}

		vcardAttrSetValue(vcards, vcard, "fn", nick);
		vcardAttrSetValue(vcards, vcard, "n", 
			lname + ";" + fname + ";" + mname);
		vcardAttrDelete(vcards, vcard, "email");
		defemail = (int)findParameter($params, "defemail", "1");
		if (sizeof(email1) > 0)
		{
			attr = vcardAttrAdd(vcards, vcard, "email", email1);
			vcardParamSet(vcards, vcard, attr, "internet", null);
			if (defemail == 1)
				vcardParamSet(vcards, vcard, attr, "pref", null);
		}

		if (sizeof(email2) > 0)
		{
			attr = vcardAttrAdd(vcards, vcard, "email", email2);
			vcardParamSet(vcards, vcard, attr, "internet", null);
			if (defemail == 2)
				vcardParamSet(vcards, vcard, attr, "pref", null);
		}

		note = getParameter($params, "note");
		if (sizeof(note) > 0)
			attr = vcardAttrSetValue(vcards, vcard, "note", note);
		else
			vcardAttrDelete(vcards, vcard, "note");

		url = getParameter($params, "url");
		if (sizeof(url) > 0)
			vcardAttrSetValue(vcards, vcard, "url", url);
		else
			vcardAttrDelete(vcards, vcard, "url");

		im = getParameter($params, "im");
		if (sizeof(im) > 0)
			vcardAttrSetValue(vcards, vcard, "im", im);
		else
			vcardAttrDelete(vcards, vcard, "im");

		vcardAttrDelete(vcards, vcard, "tel");
		defphone = (int)findParameter($params, "defphone", "1");
		phone = getParameter($params, "homephone");
		if (sizeof(phone) > 0)
		{
			attr = vcardAttrAdd(vcards, vcard, "tel", phone);
			vcardParamSet(vcards, vcard, attr, "home", null);
			if (defphone == 1)
				vcardParamSet(vcards, vcard, attr, "pref", null);
		}

		phone = getParameter($params, "workphone");
		if (sizeof(phone) > 0)
		{
			attr = vcardAttrAdd(vcards, vcard, "tel", phone);
			vcardParamSet(vcards, vcard, attr, "work", null);
			if (defphone == 2)
				vcardParamSet(vcards, vcard, attr, "pref", null);
		}

		phone = getParameter($params, "cell");
		if (sizeof(phone) > 0)
		{
			attr = vcardAttrAdd(vcards, vcard, "tel", phone);
			vcardParamSet(vcards, vcard, attr, "cell", null);
			if (defphone == 3)
				vcardParamSet(vcards, vcard, attr, "pref", null);
		}

		phone = getParameter($params, "fax");
		if (sizeof(phone) > 0)
		{
			attr = vcardAttrAdd(vcards, vcard, "tel", phone);
			vcardParamSet(vcards, vcard, attr, "fax", null);
			if (defphone == 4)
				vcardParamSet(vcards, vcard, attr, "pref", null);
		}

		val = getParameter($params, "company");
		if (sizeof(val) > 0)
			vcardAttrSetValue(vcards, vcard, "org", val);
		else
			vcardAttrDelete(vcards, vcard, "org");

		val = getParameter($params, "jobtitle");
		if (sizeof(val) > 0)
			vcardAttrSetValue(vcards, vcard, "title", val);
		else
			vcardAttrDelete(vcards, vcard, "title");

		vcardAttrDelete(vcards, vcard, "adr");
		addr1 = getParameter($params, "address");
		addr2 = getParameter($params, "city");
		addr3 = getParameter($params, "state");
		addr4 = getParameter($params, "zip");
		addr5 = getParameter($params, "country");
		if (sizeof(addr1) > 0)
		{
			attr = vcardAttrAdd(vcards, vcard, "adr", 
				addr1 + ";" + addr2 + ";" + addr3 + ";" + addr4 + ";" + addr5);
			vcardParamSet(vcards, vcard, attr, "home", null);
		}

		addr1 = getParameter($params, "workaddress");
		addr2 = getParameter($params, "workcity");
		addr3 = getParameter($params, "workstate");
		addr4 = getParameter($params, "workzip");
		addr5 = getParameter($params, "workcountry");
		if (sizeof(addr1) > 0)
		{
			attr = vcardAttrAdd(vcards, vcard, "adr", 
				addr1 + ";" + addr2 + ";" + addr3 + ";" + addr4 + ";" + addr5);
			vcardParamSet(vcards, vcard, attr, "work", null);
		}

		bday = getParameter($params, "bday");
		if (sizeof(bday) > 0)
			vcardAttrSetValue(vcards, vcard, "bday", bday);
		else
			vcardAttrDelete(vcards, vcard, "bday");

		val = getParameter($params, "spouse");
		if (sizeof(val) > 0)
			vcardAttrSetValue(vcards, vcard, "spouse", val);
		else
			vcardAttrDelete(vcards, vcard, "spouse");

		vcardUpdate(vcards);

		// Keep addrbook.ini in sync for TSP and mail filtering
		if ((envt("mailserver") == "true") && (envt("havembox") == "true"))
			addrbookExport(vcards);
	}
}


/*
** Redirect back to message when done if either set uid = imail, msgno = mail 
*/
start = findParameter($params, "start", "1");
uid = getParameter($params, "uid32");
msgno = getParameter($params, "msgno");
if (sizeof(uid) > 0)
{
	sendRedirect($response, "/sysuser/imail/mailmsg.asp?uid32=" + 
		txt2html(uid) + "&start=" + start);
}
else if (sizeof(msgno) > 0)
{
	sendRedirect($response, "/sysuser/mail/mailmsg.asp?msgno=" + 
		txt2html(msgno) + "&start=" + start);
}
else if (root == "true")
{
	sendRedirect($response, "/sysadmin/mail/contacts.asp");
}
else
{
	sendRedirect($response, home + "/index.asp");
}
%>
