<% 
setContentType($response, "text/xml");

id = getParameter($params, "id");
if (id == null)
{
        printf("No ID provided.");
	exit;
}

if (!isSambarAdminId($request, id))
{
        printf("ID provided is not for the administrator of this machine.");
	exit;
}

try
{
	alerts = alerts(20);
}
catch (e)
{
        write("<!--\n");
        write(exception(e, "info"));
        write("\n-->\n");
        printf("Alerts are not available.");
	exit;
}

url = serveruri() + "/sysadmin/";

printf("<?xml version=\"1.0\" encoding=\"iso-8859-1\" ?>\n");
printf("<?xml-stylesheet type=\"text/css\" href=\"%s/sysuser/rss.css\" ?>\n", 
	serveruri());
printf("<rss version=\"2.0\">\n");
printf("<channel><title>Alerts for %s</title>\n", envt("servername"));
printf("<link>%s</link>\n", xmlencode(url));
printf("<description>Recent Alerts</description>\n");
printf("<lastBuildDate>%s GMT</lastBuildDate>\n", envt("date_gmt"));
printf("<ttl>15</ttl>\n");

for (i = 0; i < sizeof(alerts); i++) 
{
	alert = alerts[i];

	char *datestr = NULL;
	int datetime = alert.timestamp;
	if (datetime > 0)
	{
		rectsec = gmtime(datetime, "tsec");
		datestr = strftime(datetime, "%a, %d %b %Y %T");
   	}
 	else
 	{
     	datestr = envt("date_gmt");
 	}

	printf("<item>\n");
	printf("<title>%s / %s - %s</title>\n", 
		xmlencode(alert.system), xmlencode(alert.activity),
		xmlencode(alert.message));
	printf("<link>%s</link>\n", xmlencode(url));

	printf("<pubDate>%s GMT</pubDate>\n", datestr);
	printf("</item>\n");
}
%>
</channel>
</rss>
