<% 
setContentType($response, "text/xml");

id = getParameter($params, "id");
if (id == null)
{
        printf("No ID provided.");
	exit;
}

if (!isSambarAdminId($request, id))
{
        printf("ID provided is not for the administrator of this machine.");
	exit;
}

url = serveruri() + "/sysadmin/";
url = xmlencode(url);
datestr = envt("date_gmt");
printf("<?xml version=\"1.0\" encoding=\"iso-8859-1\" ?>\n");
printf("<?xml-stylesheet type=\"text/css\" href=\"%s/sysuser/rss.css\" ?>\n",
    serveruri());
%>
<rss version="2.0">
<channel><title>Health of <%=envt("servername");%></title>
<link><%=url;%></link>
<description>High level system health report.</description>
<lastBuildDate><%=datestr;%> GMT</lastBuildDate>
<ttl>15</ttl>
<item>
  <title><%=envt("version");%> Started <%=envt("starttime");%></title>
  <link><%=url;%></link>
  <pubDate><%=datestr;%> GMT</pubDate>
</item>
<item>
  <title>Server Load <%=envt("serverload");%></title>
  <link><%=url;%></link>
  <pubDate><%=datestr;%> GMT</pubDate>
</item>
<item>
  <title>System Alerts <%= envt("alerts_recent");%> new, <%=envt("alerts_total");%> total</title>
  <link><%=url;%></link>
  <pubDate><%=datestr;%> GMT</pubDate>
</item>
<item>
  <title><%= envt("numusers");%> Users, <%=envt("threads");%> Threads, <%=envt("httpconns");%> HTTP Connections, <%=envt("allconns");%> Connections</title>
  <link><%=url;%></link>
  <pubDate><%=datestr;%> GMT</pubDate>
</item>
</channel>
</rss>
