<%
setContentType($response, "text/xml");

id = getParameter($params, "id");
if (id == null)
{
        printf("No ID provided.");
        exit;
}

if (!isSambarAdminId($request, id))
{
        printf("ID provided is not for the administrator of this machine.");
        exit;
}

type = findParameter($params, "type", "recent");
w = findParameter($params, "w", "ip");
if ((w == "ip") && (envt("throttleips") != "true"))
  	w = "user";

if ((w == "user") && (envt("throttleusers") != "true"))
	w = "vhost";

url = serveruri() + "/sysadmin/";
url = xmlencode(url);
datestr = envt("date_gmt");
printf("<?xml version=\"1.0\" encoding=\"iso-8859-1\" ?>\n");
printf("<?xml-stylesheet type=\"text/css\" href=\"%s/sysuser/rss.css\" ?>\n",
    serveruri());
%>
<rss version="2.0">
<channel><title>Throttling of <%=envt("servername");%></title>
<link><%=url;%></link>
<description>Usage and throttling report.</description>
<lastBuildDate><%=datestr;%> GMT</lastBuildDate>
<ttl>15</ttl>
%>
<%
if ((envt("throttleips") == "true") && (w == "ip"))
{
	results = ipsThrottle(type);

	num = sizeof(results);
	if (num > 20)
		num = 20;
    for (j = 0; j < num; j++) 
    {
		tip = results[j];
		title = "IP " + tip.ipaddr + " - Last Used ";
        if (tip.lastused == 0)
	    	title += "n/a";
		else
	    	title += strftime(tip.lastused, "%b %d, %Y %H:%M:%S");

		title += " - Conns " + tip.requests;

		title += " - I/O " + getSizeK((int)(tip.send / 1024)) + " / " +
	    	getSizeK((int)(tip.receive / 1024));

	%>
		<item>
  		<title><%=title;%></title>
  		<link><%=url;%></link>
  		<pubDate><%=datestr;%> GMT</pubDate>
		</item>
	<%
    } 
    %>
<%
}
else if ((envt("throttleusers") == "true") && (w == "user"))
{
	results = usersThrottle(type);

	num = sizeof(results);
	if (num > 20)
		num = 20;
    for (j = 0; j < num; j++) 
    {
		user = results[j];
		title = "User " + user.name + " - Last Login ";
        if (user.lastlogin == 0)
		{
	    	title += "n/a";
		}
		else
		{
	    	title += strftime(user.lastlogin, "%b %d, %Y %H:%M:%S");
			title += " [" + user.ipaddr + "]";
		}

		title += " - Logins " + user.logins;

		title += " - I/O " + getSizeK((int)(user.send / 1024)) + " / " +
	    	getSizeK((int)(user.receive / 1024));
	%>
		<item>
  		<title><%=title;%></title>
  		<link><%=url;%></link>
  		<pubDate><%=datestr;%> GMT</pubDate>
		</item>
	<%
    } 
    %>
<%
}
else if ((envt("throttlevhosts") == "true") && (w == "vhost"))
{
	if (type == "recent")
		type = "maxreqs";

	results = vhostsThrottle(type);
	num = sizeof(results);
	if (num > 20)
		num = 20;
    for (j = 0; j < num; j++) 
    {
		vhost = results[j];
		title = "Vhost " + vhost.name + " - Requests " + vhost.requests;

		title += " - I/O " + getSizeK((int)(vhost.send / 1024)) + " / " +
	    	getSizeK((int)(vhost.receive / 1024));
	%>
		<item>
  		<title><%=title;%></title>
  		<link><%=url;%></link>
  		<pubDate><%=datestr;%> GMT</pubDate>
		</item>
	<%
    } 
    %>
<%
}
%>
</channel>
</rss>
