<%
#include "check.asp"
area = "webdav";
task = "action";

char *name = findParameter($params, "name", "mysite.rss"); 
char *cmd = getParameter($params, "cmd"); 

filename = buildpath(path, name);
host = getHostname($request);
url = "http://" + host + path;

int updatable = docmgrUpdatable(path, name);

if ((cmd == "save") && (updatable))
{
	// Grab the RSS feed if one is specified.
	rss = NULL;
	if (isFile(getUserPath($request, filename)))
	{
   		try
   		{
       		xmlurl = XMLURLService(url + filename);
			XMLURLPropertySet(xmlurl, "timeout", "5");
			XMLURLPropertySet(xmlurl, "cacherefresh", "14400");
       		xml = XMLURLCall(xmlurl);
       		XMLURLCacheClear(xmlurl);
       		XMLURLFree(xmlurl);
			if (xml != NULL)
			{
       			rss = RSS(xml);
       			XMLFree(xml);
			}
		}
   		catch (e)
   		{
			write("<!--\n");
			write(exception(e, "info"));
			write("\n-->\n");
   		}
	}
		
	if (rss == NULL)
	{
    	struct RSS myrss;
    	rss = myrss;
	}

	rss.items = NULL; 
	rss.title = findParameter($params, "ctitle", "My Web Site");
	rss.link = findParameter($params, "clink", url + filename);
	rss.description = getParameter($params, "cdesc");

	pos = 0;
	count = 0;
	failures = 0;
	while ((failures < 5) && (count < 99))
	{
		sprintf(val, "item%d_title", count + 1);
		if (sizeof(getParameter($params, val)) > 0)
		{
			struct RSSITEM myitem;
		
			myitem.title = getParameter($params, val);
			sprintf(val, "item%d_link", count + 1);
			myitem.link = getParameter($params, val);
			sprintf(val, "item%d_desc", count + 1);
			myitem.description = getParameter($params, val);
			sprintf(val, "item%d_author", count + 1);
			myitem.author = getParameter($params, val);
			sprintf(val, "item%d_pubDate", count + 1);
			myitem.pubDate = getParameter($params, val);

			if (pos == 0)
				rss.items[] = { myitem };
			else
				rss.items[pos] = myitem;
			pos++;
		}
		else
		{
			failures++;
		}

		count++;
	}

	RSSSave(rss, getUserPath($request, filename));
	sendRedirect($response, "/sysuser/index.asp");
}

#include "../header.asp"
base = findParameter($params, "base", "index.asp");
%>
<table border=0 cellpadding=4 cellspacing=4>
<tr valign=top><td nowrap>
<% #include "side.asp" %>
</td><td nowrap width="100%">
	<script language="JavaScript">
	<!--
	function saveChannel(n)
	{
		document.rssForm.cmd.value = "save";
		document.rssForm.submit();
	}

	function cancelChannel(n)
	{
		document.rssForm.action = "/sysuser/index.asp";
		document.rssForm.submit();
	}

	function insertItem(n)
	{
		document.rssForm.cmd.value = "insert";
		document.rssForm.item.value = n;
		document.rssForm.submit();
	}

	function deleteItem(n)
	{
		document.rssForm.cmd.value = "delete";
		document.rssForm.item.value = n;
		document.rssForm.submit();
	}

	function resetRSSForm(row)
	{
		rsselmt = eval("document.rssForm.rss" + row);
		nameelmt = eval("document.rssForm.item" + row + "_title");
		urlelmt = eval("document.rssForm.item" + row + "_link");
		id = rsselmt[rsselmt.selectedIndex].value;
		rsselmt.selectedIndex = 0;
		switch (id)
		{
		case '1':
			nameelmt.value = "BBC World News";
			urlelmt.value = "http://news.bbc.co.uk/rss/newsonline_uk_edition/world/rss091.xml";
			break;
		case '2':
			nameelmt.value = "Reuters News";
			urlelmt.value = "http://www.microsite.reuters.com/rss/topNews";
			break;
		case '3':
			nameelmt.value = "Yahoo News";
			urlelmt.value = "http://rss.news.yahoo.com/rss/topstories";
			break;
		case '4':
			nameelmt.value = "ABC News Politics";
			urlelmt.value = "http://my.abcnews.go.com/rsspublic/politics_rss093.xml";
			break;
		case '5':
			nameelmt.value = "Wired News";
			urlelmt.value = "http://www.wired.com/news_drop/netcenter/netcenter.rdf";
			break;
		case '6':
			nameelmt.value = "Christian Science Monitor";
			urlelmt.value = "http://www.csmonitor.com/rss/top.rss";
			break;
		case '7':
			nameelmt.value = "Yahoo Sports";
			urlelmt.value = "http://rss.news.yahoo.com/rss/sports";
			break;
		case '8':
			nameelmt.value = "RollingStone.com";
			urlelmt.value = "http://www.rollingstone.com/rssxml/album_reviews.xml";
			break;
		case '9':
			nameelmt.value = "NewsForge";
			urlelmt.value = "http://www.newsforge.com/reports.rss";
			break;
		case '10':
			nameelmt.value = "Slashdot";
			urlelmt.value = "http://slashdot.org/slashdot.rss";
			break;
		case '11':
			nameelmt.value = "Security Focus";
			urlelmt.value = "http://www.securityfocus.com/rss/news.xml";
			break;
		case '12':
			nameelmt.value = "Reuters Leisure";
			urlelmt.value = "http://www.microsite.reuters.com/rss/lifeAndLeisureNews";
			break;
		case '13':
			nameelmt.value = "Yahoo Entertainment";
			urlelmt.value = "http://rss.news.yahoo.com/rss/entertainment";
			break;
		case '14':
			nameelmt.value = "Microsoft Security Alerts";
			urlelmt.value = "http://www.microsoft.com/technet/security/bulletin/secrss.aspx";
			break;
		default:
			break;
		}
	}
	//-->
	</script>
	<% 
	int item = (int)findParameter($params, "item", "0"); 

	if (updatable)
	{
		// Grab the RSS feed if one is specified.
		rss = NULL;
		if (isFile(getUserPath($request, filename)))
		{
    		try
    		{
        		xmlurl = XMLURLService(url + filename);
        		xml = XMLURLCall(xmlurl);
				if (cmd == "delete")
        			XMLURLCacheClear(xmlurl);
        		XMLURLFree(xmlurl);
				if (xml != NULL)
				{
        			rss = RSS(xml);
        			XMLFree(xml);
				}
    		}
    		catch (e)
    		{
        		// Ignore feed failres, just message below.
				write("<!--\n");
				write(exception(e, "info"));
				write("\n-->\n");
    		}
  		}

		if ((cmd == "delete") && 
			(rss != NULL) && 
			(item > 0) &&
			(item <= sizeof(rss.items)))
		{
			rss.items[item - 1] = NULL;
			RSSSave(rss, getUserPath($request, filename));
			printf("<center><div class=\"info\">");
			printf("Site feed deleted.");
			printf("</div></center>");

			// After saving, reload RSS to verify changes.
    		try
    		{
        		xmlurl = XMLURLService(url + filename);
        		xml = XMLURLCall(xmlurl);
				if ((cmd == "save") || (cmd == "delete"))
        			XMLURLCacheClear(xmlurl);
        		XMLURLFree(xmlurl);
				if (xml != NULL)
				{
        			rss = RSS(xml);
        			XMLFree(xml);
				}
    		}
    		catch (e)
    		{
        		// Ignore feed failres, just message below.
				write("<!--\n");
				write(exception(e, "info"));
				write("\n-->\n");
    		}
		}

		%>
		<TABLE border=0 cellspacing=8>
		<TR><TD>
		<br>
		<B><FONT SIZE=+1>My Web Site Editor</FONT></B><BR>
		<FORM name="rssForm" METHOD=POST ACTION="<%=home;%>/mysite.asp">
		<input type="hidden" name="item" value="">
		<input type="hidden" name="cmd" value="">
		<input type="hidden" name="home" value="<%=home;%>">
		<input type="hidden" name="path" value="<%=txt2html(path);%>">
		<input type="hidden" name="name" value="<%=txt2html(name);%>">
		<input type="hidden" name="base" value="<%=txt2html(base);%>">
		<input type="hidden" name="ctitle" value="My Web Site"/>
		<input type="hidden" name="clink" value="<%=rss ? rss.link : url + filename;%>"/>
	
		<TABLE border=0 cellspacing=4 width=100%>
		<tr><td colspan=3>
        <input type="button" class="mod" name="save" value="Save" onclick="saveChannel()">
		<input type="button" class="mod" name="cancel" value="Cancel" onclick="cancelChannel()">
		</td></tr>
	
		<%
		total = 0;
		if (rss != NULL)
		{
			for (i = 0; i < sizeof(rss.items); i++)
			{
				rssitem = rss.items[i];
				if (rssitem == NULL)
					continue;

				total++;
				
				// Insert a "blank" item?
				if ((cmd == "insert") && (item == total))
				{
				%>
					<tr><td bgcolor="#ccccff" colspan="3"><B>RSS Feed <%=total;%></B></th></tr>
					<input type="hidden" name="item<%=total;%>_desc" value="">
					<tr><td align="right">Title</td>
					<td><input type="text" name="item<%=total;%>_title" value="" size="20"/></td><td>
					<select name="rss<%=total;%>" onChange="resetRSSForm('<%=total;%>')">
					<option value= '0'> -- Select Pre-defined Feed -- 
					<option value= '1'> BBC World News
					<option value= '2'> Reuters News
					<option value= '3'> Yahoo News
					<option value= '4'> ABC News Politics
					<option value= '5'> Wired News
					<option value= '6'> Christian Science Monitor
					<option value= '7'> Yahoo Sports
					<option value= '8'> RollingStone.com
					<option value= '9'> NewsForge
					<option value= '10'> Slashdot
					<option value= '11'> Security Focus
					<option value= '14'> Microsoft Security Alerts
					<option value= '12'> Reuters Life and Leisure
					<option value= '13'> Yahoo Entertainment
					</select>
					</td></tr>
					<tr><td align="right">URL</td>
					<td colspan=2><input type="text" name="item<%=total;%>_link" value="" size="50"/></td></tr>
				<%
					total++;
				}

				%>
				<tr><td bgcolor="#ccccff" colspan="3"><B>RSS Feed <%=total;%></B></th></tr>
				<input type="hidden" name="item<%=total;%>_author" value="<%=txt2html(rssitem.author);%>"/>
				<input type="hidden" name="item<%=total;%>_pubDate" value="<%=txt2html(rssitem.pubDate);%>"/>
				<input type="hidden" name="item<%=total;%>_desc" value=""/>
				<tr><td align="right">Title</td>
				<td><input type="text" name="item<%=total;%>_title" value="<%=txt2html(rssitem.title);%>" size="20"/></td>
				<td align="right">
				<input type="button" class="mod" name="delete" value="Delete" onclick="deleteItem(<%=(i+1);%>)"/>
				<input type="button" class="mod" name="insert" value="Insert" onclick="insertItem(<%=(i+1);%>)"/></td></tr>

				<tr><td align="right">URL</td>
				<td colspan=2><input type="text" name="item<%=total;%>_link" value="<%=txt2html(rssitem.link);%>" size="50"/></td></tr>
				<%
			}
		}
	
		for (i = 0; i < 3; i++)
		{
			total++;
		%>
			<tr><td bgcolor="#ccccff" colspan="3"><B>RSS Feed <%=total;%></B></th></tr>
			<input type="hidden" name="item<%=total;%>_desc" value="">
			<tr><td align="right">Title</td>
			<td><input type="text" name="item<%=total;%>_title" value="" size="20"/></td>
			<td>
			<select name="rss<%=total;%>" onChange="resetRSSForm('<%=total;%>')">
			<option value= '0'> -- Select Pre-defined Feed -- 
			<option value= '1'> BBC World News
			<option value= '2'> Reuters News
			<option value= '3'> Yahoo News
			<option value= '4'> ABC News Politics
			<option value= '5'> Wired News
			<option value= '6'> Christian Science Monitor
			<option value= '7'> Yahoo Sports
			<option value= '8'> RollingStone.com
			<option value= '9'> NewsForge
			<option value= '10'> Slashdot
			<option value= '11'> Security Focus
			<option value= '14'> Microsoft Security Alerts
			<option value= '12'> Reuters Life and Leisure
			<option value= '13'> Yahoo Entertainment
			</select>
			</td></tr>
			<tr><td align="right">URL</td>
			<td colspan=2><input type="text" name="item<%=total;%>_link" value="" size="50"/>
			<% if (i == 1) { %>
			<br><small><i>i.e. http://slashdot.org/slashdot.rss</i></small>
			<% } %>
			</td></tr>
		<%
		}

		%>
		<tr><td colspan=3>
        <input type="button" class="mod" name="save" value="Save" onclick="saveChannel()">
		<input type="button" class="mod" name="cancel" value="Cancel" onclick="cancelChannel()">
		</td></tr>
		<%
	}
	else
	{
		printf("<B>Site file '%s' is not updatable.</B>", name);
	}
	%>
	</TABLE>
	</FORM>
	</TD></TR>
	</TABLE>
</td></tr></table>
<br>
<% #include "../footer.asp" %>
