<% 
#include "check.asp"
#include "dminfo.asp"

char *name = getParameter($params, "name"); 
if (sizeof(name) == 0)
	exit;
char *cmd = getParameter($params, "cmd"); 
int item = (int)findParameter($params, "item", "0"); 

filename = buildpath(path, name);
int updatable = docmgrUpdatable(path, name);
if (updatable)
{
	rss = null;
	char *userpath = getUserPath($request, filename);
	try
	{
		xml = XMLOpen(userpath, 0);
		if (xml != NULL)
		{
			rss = RSS(xml);
    		XMLFree(xml);
		}
	}
	catch (e)
	{
		// Ignore feed failres, just message below.
		write("<!--\n");
		write(exception(e, "info"));
		write("\n-->\n");
	}

	if ((cmd == "del") && 
		(rss != NULL) && 
		(item > 0) &&
		(item <= sizeof(rss.items)))
	{
		rss.items[item - 1] = NULL;
		RSSSave(rss, userpath);
	}
	else if ((cmd == "upd") && 
		(rss != NULL) && 
		(sizeof(getParameter($params, "title")) > 0) &&
		(sizeof(getParameter($params, "priority")) > 0) &&
		(item > 0) &&
		(item <= sizeof(rss.items)))
	{
		myitem = rss.items[item - 1];
		myitem.title = getParameter($params, "priority") + "-" +
			getParameter($params, "title");
		myitem.description = getParameter($params, "description");
		myitem.author = envt("username");
		myitem.security = findParameter($params, "security", "pub");
		rss.items[item - 1] = myitem;
		RSSSort(rss, "title");
		RSSSave(rss, userpath);
	}
	else if ((cmd == "add") && 
		(rss != NULL) && 
		(sizeof(getParameter($params, "title")) > 0) &&
		(sizeof(getParameter($params, "priority")) > 0))
	{
		struct RSSITEM myitem;
		myitem.guid = uuid();
		myitem.title = getParameter($params, "priority") + "-" +
			getParameter($params, "title");
		myitem.description = getParameter($params, "description");
		myitem.author = envt("username");
		myitem.security = findParameter($params, "security", "pub");

		if (sizeof(rss.items) == 0)
			rss.items[] = { myitem };
		else
			rss.items[sizeof(rss.items)] = myitem;
		RSSSort(rss, "title");
		RSSSave(rss, userpath);
	}
}

sendRedirect($response, home + "/index.asp?path=" + urlencode(path) +
	"&name=" + urlencode(name));
%>
