/*
** echoStructArray web service handler.
*/
value = soapParameterGet($soap, "echoStructArray");
if (!isArray(value) || (sizeof(value) != 3))
{
	soapResultError($soap, "none", "Unexpected structure array size.");
}
else
{
	s1 = value[0];
	s2 = value[1];
	s3 = value[2];
	if ((s1.varInt != 1) || 
		(s2.varInt != 2) || 
		(s3.varInt != 3) ||
	    	(s1.varFloat != 1.1) || 
		(s2.varFloat != 1.2) || 
	    	(s3.varFloat != 1.3) ||
	    	(s1.varString != "Hello1") || 
		(s2.varString != "Hello2") || 
	    	(s3.varString != "Hello3"))
	{
		soapResultError($soap, "none", 
			"Unexpected structure values.");
	}
	else
	{
		soapResultAdd($soap, NULL, value);
	}
}
