<% 
#include "check.asp" 

// Append the name to the path if passed in.
char *name = getParameter($params, "name");
if (sizeof(name) > 0)
	path = buildpath(path, name);

area = "blog";
#include "../header.asp" 
#include "dminfo.asp" 

dmprop = NULL;
if (dminfo != NULL)
{
	try
	{
    	int pos = lastIndexOf(path, '/');
    	char *rootpath = substr(path, 0, pos + 1);
    	char *name = substr(path, pos + 1, sizeof(path));

    	dmprop = docmgrProp(rootpath, name);
	}
	catch (e)
	{
    	write("<!--\n");
    	write(exception(e, "info"));
    	write("\n-->\n");
	}
}

blogpath = path + "/blogdata";
date = findParameter($params, "date", strftime(time(), "%Y-%m-%d"));
blogentry = date + ".htm";
%>
<table border=0 cellpadding=4 cellspacing=4>
<tr valign=top><td nowrap>
<% #include "side.asp" %>
</td><td nowrap width="100%">
    <script language="JavaScript">
    <!--
    function confirmDelete()
    {
    	return confirm("Delete selected blog entry?");
	}
	-->
	</script>
	<% err = getParameter($params, "err");
	   if (sizeof(err) > 0) { 
	%>
		<BLOCKQUOTE>
		<div class="error"><B>Error! <%=err;%></B></div>
		</BLOCKQUOTE>
		<BR>
	<% } %>
<% if ((dminfo == NULL) || (dmprop == NULL)) { %>

	<TABLE border=0 cellspacing=8>
	<TR><TD>
	<I>Your blog has not yet been initialized.<br>
	Please fill out this form to begin blogging.</I><br><br>
	<FORM METHOD="POST" ACTION="/session/dm-mkblog" 
	onSubmit="return validateForm(this)">
	<input type=hidden name="home" value="<%=home;%>">
	<input type=hidden name="path" value="<%=txt2html(path);%>">
	<input type=hidden name="base" value="index.asp">
	<input type=hidden name="overwrite" value="true">
	<TABLE border=0 cellspacing=4>
    <TR valign=top><TD nowrap><B>Title</B></TD>
		<TD><input type=text name="title" value="<%=envt("username");%>'s thoughts..." size=40 maxlength=60 required="true"></TD></TR>
	<TR valign=top><TD nowrap><B>Description</B></TD>
	    <TD><textarea rows=4 cols=60 name="description" maxlength="400"></textarea></TD></TR>

	<TR valign=top><TD nowrap><B>Theme</B></TD>
	  <TD><select name="css">
		<option value="/sysuser/webdav/css/blog1.css"> Modern
		<option value="/sysuser/webdav/css/blog2.css"> Classic
		<option value="/sysuser/webdav/css/blog3.css"> Contemporary (white)
		<option value="/sysuser/webdav/css/blog5.css"> Contemporary (black)
		<option value="/sysuser/webdav/css/blog4.css"> Stylish
		<option value="/sysuser/webdav/css/blog6.css"> Deep Blue
		<option value="/sysuser/webdav/css/blog7.css"> Deep Green
		<option value="/sysuser/webdav/css/blog8.css"> Deep Red
		<option value="/sysuser/webdav/css/blog9.css"> Deep Purple
		</select>
 	  </TD></TR>
	</TABLE>

	</TD></TR>
	</TABLE>
	<br>
	<input type=submit class="mod" value="Create Blog">
	</FORM>
	</TD></TR>
	</TABLE>

<% } else { %>

    <div id="m_2" class="ebox" style="position:relative">
    <table border=0 cellpadding=2 cellspacing=0 width=100%>
    <tr bgcolor=#efefef><td nowrap>&nbsp;Blog 
	<B><%=txt2html(dmprop.title);%></B>
	&nbsp;&nbsp;&nbsp;&nbsp;<small>[
	<a href="http://<%=getHostname($request) + userhome + txt2html(path);%>">
	http://<%=getHostname($request) + userhome + txt2html(path);%></a>
	]</small>
	</td>
	<% if (dminfo.updatable) { %>
    <td align=right><a href="#" class=el onclick="return edit(2);">
    <font size=-1>edit</font></a>
    <a href="#" class=csl onclick="return cedit(2);"><font size=-1>close edit</font></a></td>
    </tr>

    <tr class=es><td colspan=2>
    <form name=blogForm action="/session/dm-mkblog" method=post style="display:inline" onSubmit="return validateForm(this);">
	<input type=hidden name="home" value="<%=home;%>">
	<input type=hidden name="path" value="<%=txt2html(path);%>">
	<input type=hidden name="base" value="index.asp">
	<input type=hidden name="overwrite" value="true">

	<TABLE border=0 cellpadding=2 cellspacing=2>
	<TR valign=top><TD nowrap><B>Title</B></TD>
	    <TD><input type=text name="title" value="<%=txt2html(dmprop.title);%>" size=40 maxlength=60 required="true"></TD></TR>
	<TR valign=top><TD nowrap><B>Description</B></TD>
	    <TD><textarea rows=4 cols=60 name="description" maxlength="400"><%=txt2html(dmprop.description);%></textarea></TD></TR>

    <TR valign=top><TD nowrap><B>Theme</B></TD>
      <TD><select name="css">
        <option value="/sysuser/webdav/css/blog1.css" <% if (dmprop.css == "/sysuser/webdav/css/blog1.css") printf("SELECTED");%>> Modern
        <option value="/sysuser/webdav/css/blog2.css" <% if (dmprop.css == "/sysuser/webdav/css/blog2.css") printf("SELECTED");%>> Classic
        <option value="/sysuser/webdav/css/blog3.css" <% if (dmprop.css == "/sysuser/webdav/css/blog3.css") printf("SELECTED");%>> Contemporary (white)
        <option value="/sysuser/webdav/css/blog5.css" <% if (dmprop.css == "/sysuser/webdav/css/blog5.css") printf("SELECTED");%>> Contemporary (black)
        <option value="/sysuser/webdav/css/blog4.css" <% if (dmprop.css == "/sysuser/webdav/css/blog4.css") printf("SELECTED");%>> Stylish
	<option value="/sysuser/webdav/css/blog6.css" <% if (dmprop.css == "/sysuser/webdav/css/blog6.css") printf("SELECTED");%>> Deep Blue
	<option value="/sysuser/webdav/css/blog7.css" <% if (dmprop.css == "/sysuser/webdav/css/blog7.css") printf("SELECTED");%>> Deep Green
	<option value="/sysuser/webdav/css/blog8.css" <% if (dmprop.css == "/sysuser/webdav/css/blog8.css") printf("SELECTED");%>> Deep Red
	<option value="/sysuser/webdav/css/blog9.css" <% if (dmprop.css == "/sysuser/webdav/css/blog9.css") printf("SELECTED");%>> Deep Purple
        </select>
      </TD></TR>
	</TABLE>
	<br>
	<input type=submit class="mod" value="Update Blog">
	</FORM>
	</td>
	<% } %>
	</tr></table>
	</div>

	<% if (dminfo.updatable) { %>
    <table border=0 cellpadding=2 cellspacing=0 width=100%>
  	<tr><td bgcolor="#DADFEC"> 
	<font face="verdana, arial" size="2" class="text"><b>
	<A HREF="<%=home;%>/blogedit.asp?path=<%=txt2html(path);%>">Create Blog Entry</A>
	</b></font>
	</td></tr>
	</table>
	<BR>
	<% } %>

	<%
    try
    {
    	dmblogdata = docmgrInfo(path + "/blogdata");
        if (dmblogdata != NULL)
		{
			total = 0;
 			ls = ls(dmblogdata.realpath);
			rsort(ls);

			printf("<table border=0 cellpadding=2 cellspacing=0>\n");

			col = 0;
			for (i = 0; i < sizeof(ls); i++)
			{
				name = ls[i];
				namelen = strlen(name);
				if (strcasecmp(&name[namelen - 4], ".htm") == 0)
				{
					dmentry = docmgrProp(path + "/blogdata", name);
					if ((dmentry != NULL) && (sizeof(dmentry.title) > 0))
						title = dmentry.title;
					else
						title = "Untitled...";

					name[namelen - 4] = '\0';
					
					if (col == 0)
						printf("<tr valign=top>");
	
					printf("<td nowrap>");
					printf("<small>[%s]</small>&nbsp;", txt2html(name));
					printf("<a title=\"View/Edit Entry\" href=\"%s/blogedit.asp?path=%s&date=%s\">", 
						txt2html(home), txt2html(path), txt2html(name));
					printf("%s</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;", 
						txt2html(title));

					if (dminfo.updatable) 
					{
						printf("<a title=\"Remove\" href=\"/session/dm-delete?home=%s&path=%s&name=blogdata/%s.htm\" onClick=\"return confirmDelete()\"><img border=0 src=/sysimage/icons/delete.gif></a>", 
							txt2html(home), txt2html(path), txt2html(name));
					}

					printf("&nbsp;&nbsp;&nbsp;&nbsp;</td>\n");
					total++;
					col++;

					if (col == 2)
					{
						col = 0;
						printf("</tr>\n");
					}
				}
			}

			if ((total > 0) && (col != 0))
				printf("</tr>\n");
		
			printf("</table>");

			if (total == 0)
				printf("<I>No blog entries have been created.</I>");
		}
    }
    catch (e)
    {
        write("<!--\n");
        write(exception(e, "info"));
        write("\n-->\n");
        printf("<BR><B>" + exception(e, "message") + "</B><BR>");
    }
	%>

<% } %>
	<br>
	<br>
	<% if (isSambarAdmin($request) && dminfo != NULL) { %>
	    <B>Real Path:</B> <small><%=dminfo.realpath;%></small>
	<%  } %>
</td></tr></table>
<br>
<% #include "../footer.asp" %>
