<% 
#include "check.asp"
area = "calendar";
#include "../header.asp" 
#include "dminfo.asp"

calpath = path + "/caldata";
view = findParameter($params, "view", "month");
item = (int)findParameter($params, "item", "0");
rssfile = date + ".rss";

curhour = strftime(time() + 3600, "%H");
curmin = "00";
durhour = 1;
durmin = 0;
security = "pub";

filename = buildpath(calpath, rssfile);
host = getHostname($request);
url = "http://" + host;
if (envt("userdir") == "true")
	url = url + "/~" + envt("username");
else
	url = url + envt("userhome");

int updatable = docmgrUpdatable(calpath, rssfile);
if (!updatable)
{
	write("<!-- RSS file : " + rssfile + " is not updatable -->\n");
}

char *userpath = getUserPath($request, filename);
rss = null;
rssitem = null;
try
{
	xml = XMLOpen(userpath, 0);
	if (xml != NULL)
	{
		rss = RSS(xml);
		RSSSort(rss, "startdate");
    	XMLFree(xml);
		if ((item > 0) && (item <= sizeof(rss.items)))
		{
			rssitem = rss.items[item - 1];
			security = rssitem.security;
			curhour = gmstrftime(rssitem.startdate + (-timezone * 3600), "%H");
			curmin = gmstrftime(rssitem.startdate + (-timezone * 3600), "%M");

			durhour = (int)((rssitem.enddate - rssitem.startdate) / 3600);
			if (durhour > 8)
				durhour = 8;
			durmin = (int)(((rssitem.enddate - rssitem.startdate) % 3600) / 60);
		}
	}
}
catch (e)
{
	// Ignore feed failres, just message below.
	write("<!--\n");
	write(exception(e, "info"));
	write("\n-->\n");
}
%>
<table border=0 cellpadding=4 cellspacing=4>
<tr valign=top><td nowrap>
<% #include "side.asp" %>
</td><td nowrap width="100%">
	<link rel="stylesheet" href="/sysuser/rte/rte.css" type="text/css">
	<script src="/sysuser/calendar.js"></script>
	<script language="JavaScript" type="text/javascript" src="/sysuser/rte/richtext.js"></script>
	<SCRIPT language="JavaScript">
	<!--
	function doValidate(theForm)
	{
		if (!validateForm(theForm))
			return (false);

		updateRTE('content');
		return (true);
	}

	initRTE("/sysuser/rte/images/", "/sysuser/rte/");
	//-->
	</SCRIPT>
    <% err = getParameter($params, "err");
       if (sizeof(err) > 0) {
    %>
        <BLOCKQUOTE>
        <div class="error"><B>Error! <%=err;%></B></div>
        </BLOCKQUOTE>
        <BR>
    <% } %>
	<% #include "actions.asp" %>
	<TABLE border=0 cellspacing=8>
	<TR><TD>
	<% if (rssitem == null) { %>
		<B><FONT SIZE=+1>Add Calendar Event</FONT></B>
	<% } else { %>
		<B><FONT SIZE=+1>Update Calendar Event</FONT></B>
	<% } %>
	<br/>
	<% if (privs & PRIV_READWRITE) { %>
		<FORM METHOD="POST" ACTION="<%=home;%>/modify.asp" onsubmit="return doValidate(this)">
		<input type=hidden name="path" value="<%=txt2html(path);%>">
		<input type=hidden name="view" value="<%=txt2html(view);%>">
		<input type=hidden name="origdate" value="<%=txt2html(date);%>">
		<TABLE border=0 cellspacing=4>
    	<TR><TD><B>Date</B></TD>
		<TD><input id="calentry" type="text" name="date" size="10" maxlength="10" value="<%=txt2html(date);%>" required="true">
		<a href="javascript:caldate.popup();"><img valign="bottom" src="/sysimage/system/cal.gif" width="16" height="16" border="0" alt="Click Here to set the date"></a>
    	</TD></TR>
    	<TR><TD><B>Time</B></TD><TD nowrap>
			<select name="starthour" size="1" style="font-size:11px;" >
			<option value="00" <% if (curhour == "00") printf("selected");%>>12 am</option>
			<option value="01" <% if (curhour == "01") printf("selected");%>>1 am</option>
			<option value="02" <% if (curhour == "02") printf("selected");%>>2 am</option>
			<option value="03" <% if (curhour == "03") printf("selected");%>>3 am</option>
			<option value="04" <% if (curhour == "04") printf("selected");%>>4 am</option>
			<option value="05" <% if (curhour == "05") printf("selected");%>>5 am</option>
			<option value="06" <% if (curhour == "06") printf("selected");%>>6 am</option>
			<option value="07" <% if (curhour == "07") printf("selected");%>>7 am</option>
			<option value="08" <% if (curhour == "08") printf("selected");%>>8 am</option>
			<option value="09" <% if (curhour == "09") printf("selected");%>>9 am</option>
			<option value="10" <% if (curhour == "10") printf("selected");%>>10 am</option>
			<option value="11" <% if (curhour == "11") printf("selected");%>>11 am</option>
			<option value="12" <% if (curhour == "12") printf("selected");%>>12 pm</option>
			<option value="13" <% if (curhour == "13") printf("selected");%>>1 pm</option>
			<option value="14" <% if (curhour == "14") printf("selected");%>>2 pm</option>
			<option value="15" <% if (curhour == "15") printf("selected");%>>3 pm</option>
			<option value="16" <% if (curhour == "16") printf("selected");%>>4 pm</option>
			<option value="17" <% if (curhour == "17") printf("selected");%>>5 pm</option>
			<option value="18" <% if (curhour == "18") printf("selected");%>>6 pm</option>
			<option value="19" <% if (curhour == "19") printf("selected");%>>7 pm</option>
			<option value="20" <% if (curhour == "20") printf("selected");%>>8 pm</option>
			<option value="21" <% if (curhour == "21") printf("selected");%>>9 pm</option>
			<option value="22" <% if (curhour == "22") printf("selected");%>>10 pm</option>
			<option value="23" <% if (curhour == "23") printf("selected");%>>11 pm</option>
			</select>
    		<select name="startmin">
    		<option value="00" <% if (curmin == "00") printf("selected");%>>:00</option>
    		<option value="15" <% if (curmin == "15") printf("selected");%>>:15</option>
    		<option value="30" <% if (curmin == "30") printf("selected");%>>:30</option>
    		<option value="45" <% if (curmin == "45") printf("selected");%>>:45</option>
    		</select>
    	</TD></TR>
    	<TR><TD><B>Duration</B></TD><TD nowrap>
			<select name="durhour" size="1" style="font-size:11px;" >
			<option value="0" <% if (durhour == 0) printf("selected");%>>0 hours</option>
			<option value="1" <% if (durhour == 1) printf("selected");%>>1 hour</option>
			<option value="2" <% if (durhour == 2) printf("selected");%>>2 hours</option>
			<option value="3" <% if (durhour == 3) printf("selected");%>>3 hours</option>
			<option value="4" <% if (durhour == 4) printf("selected");%>>4 hours</option>
			<option value="5" <% if (durhour == 5) printf("selected");%>>5 hours</option>
			<option value="6" <% if (durhour == 6) printf("selected");%>>6 hours</option>
			<option value="7" <% if (durhour == 7) printf("selected");%>>7 hours</option>
			<option value="8" <% if (durhour == 8) printf("selected");%>>8 hours</option>
			</select>&nbsp;
        	<select name="durmin" size="1" style="font-size:11px;" >
			<option value="0" <% if (durmin == 0) printf("selected");%>>0 minutes</option>
			<option value="15" <% if (durmin == 15) printf("selected");%>>15 minutes</option>
			<option value="30" <% if (durmin == 30) printf("selected");%>>30 minutes</option>
			<option value="45" <% if (durmin == 45) printf("selected");%>>45 minutes</option>
			</select>
    	</TD></TR>
		<TR><TD><B>Title</B></TD><TD><input type="text" name="title" size="60" maxlength="80" value="<%=(rssitem ? txt2html(rssitem.title) : "");%>" required="true"></TD></TR>
		<TR><TD><B>Event URL</B></TD>
		<TD><input type="text" name="link" size="60" maxlength="255" value="<%=(rssitem ? txt2html(rssitem.link) : "");%>"></TD></TR>
		<TR><TD><B>Privacy Setting</B></TD>
		<TD><small>
			<input type="radio" name="security" value="pub" <% if (security == "pub") printf("CHECKED");%>> Public
			&nbsp;&nbsp;&nbsp;&nbsp;
	    	<input type="radio" name="security" value="prv" <% if (security != "pub") printf("CHECKED");%>> Private
    	</small></TD></TR>
		<TR><TD colspan=2>
		<script language="JavaScript" type="text/javascript">
		<!--
		writeRichText('content', 
			'<%=txt2rtesafe(rssitem ? rssitem.description : "");%>', 
			400, 200, true, false, false);
		//-->
		</script>
		</TD></TR>
		<% if (rssitem == null) { %>
			<TR valign=top><TD><B>Recurrence</B></TD>
			<TD><small><b>Repeat:</b>
				&nbsp;<input type="radio" name="recur" value="0" checked>&nbsp;None
				&nbsp;<input type="radio" name="recur" value="1" >&nbsp;Daily
				&nbsp;<input type="radio" name="recur" value="2" >&nbsp;Weekly	
				&nbsp;<input type="radio" name="recur" value="3" >&nbsp;Monthly
			<br>
			<b>How Often:</b>
				&nbsp;&nbsp;
				<select name="recurfreq" size="1" style="font-size:11px;">
				<option value="0">-- None --</option>
				<option value="1" >1</option>
				<option value="2" >2</option>
				<option value="3" >3</option>
				<option value="4" >4</option>
				<option value="5" >5</option>
				<option value="10" >10</option>
				<option value="15" >15</option>
				<option value="20" >20</option>
				</select>  
				&nbsp;times</small>
    		</TD></TR>
		<% } %>
		</TABLE>

		<% if (rssitem == null) { %>
		<input type=hidden name="cmd" value="add">
		<input type=submit class="mod" value="Add Entry">
		<% } else { %>
		<input type=hidden name="cmd" value="upd">
		<input type=hidden name="item" value="<%=item;%>">
		<input type=submit class="mod" value="Update Entry">
		<% } %>
		</FORM>
	<% } else { %>
		<TABLE border=0 cellspacing=4>
    	<TR><TD><B>Date</B></TD>
		<TD><%=txt2html(date);%>
    	</TD></TR>
    	<TR><TD><B>Time</B></TD><TD nowrap>
			<%=txt2html(curhour);%>:<%=txt2html(curmin);%>
    	</TD></TR>
    	<TR><TD><B>Duration</B></TD><TD nowrap>
			<% if (durhour > 0) { %>
				<%=durhour;%> hour(s)
			<% } %>
			<% if (durmin > 0) { %>
				<%=durmin;%> minutes
			<% } %>
    	</TD></TR>
		<TR><TD><B>Title</B></TD><TD><%=(rssitem ? txt2html(rssitem.title) : "");%></TD></TR>
		<TR><TD><B>Event URL</B></TD>
		<TD><%=(rssitem ? txt2html(rssitem.link) : "");%></TD></TR>
		<TR><TD><B>Privacy Setting</B></TD>
		<TD><small>
			<% if (security == "pub") { %>
			Public
			<% } else { %>
			Private
			<% } %>
    	</small></TD></TR>
		<TR><TD colspan=2>
			<%=txt2rtesafe(rssitem ? rssitem.description : "");%>
		</TD></TR>
		</TABLE>
	<% } %>
	</TD></TR>
	</TABLE>
    <SCRIPT language="JavaScript">
    <!--
    var caldate = new calendar2(_gid("calentry"));
    caldate.year_scroll = true;
    caldate.time_comp = false;
    //-->
    </SCRIPT>
</td></tr></table>
<br>
<% #include "../footer.asp" %>
