<%
// Retrieve document manager navigation information.
dminfo = NULL;
dmprop = NULL;
timezone = 0;
try
{
	dminfo = docmgrInfo(path);
	if (dminfo != NULL)
	{
        int pos = lastIndexOf(path, '/');
        char *rootpath = substr(path, 0, pos + 1);
        char *dirname = substr(path, pos + 1, sizeof(path));

        dmprop = docmgrProp(rootpath, dirname);
		if (dmprop != NULL)
			timezone = (int)dmprop.timezone;
	}
}
catch (e)
{
	write("<!--\n");
	write(exception(e, "info"));
	write("\n-->\n");
}

date = getParameter($params, "date");
if (sizeof(date) != 10)
{
	t = time() + timezone * 3600;
	date = gmstrftime(t, "%Y-%m-%d");
}

year = atoi(date);
mon = atoi(&date[5]);
day = atoi(&date[8]);
if ((year < 1900) || (year > 2037) ||
        (mon < 1) || (mon > 12) ||
        (day < 1) || (day > 31))
{
	t = time() + timezone * 3600;
	date = gmstrftime(t, "%Y-%m-%d");
	year = atoi(date);
	mon = atoi(&date[5]);
	day = atoi(&date[8]);
}
%>
