<%
showDay(char *thedate)
{
	rssfile = thedate + ".rss";
	filename = buildpath(calpath, rssfile);
	host = getHostname($request);
	url = "http://" + host;
	if (envt("userdir") == "true")
    		url = url + "/~" + envt("username");
	else
    		url = url + envt("userhome");

	int updatable = docmgrUpdatable(calpath, rssfile);
	char *userpath = getUserPath($request, filename);

	rss = null;
	try
	{
		xml = XMLOpen(userpath, 0);
		if (xml != NULL)
		{
			rss = RSS(xml);
			RSSSort(rss, "startdate");
			XMLFree(xml);
		}
	}
	catch (e)
	{
		// Ignore feed failres, just message below.
		write("<!--\n");
		write(exception(e, "info"));
		write("\n-->\n");
	}

	if ((rss != null) && (sizeof(rss.items) > 0))
	{
		if (view == "day")
			printf("<table width=\"100%\" cellpadding=4 border=0>");

		for (i = 0; i < sizeof(rss.items); i++)
		{
			rssitem = rss.items[i];
			if (sizeof(rssitem.title) == 0)
				continue;

			starttime = gmstrftime(rssitem.startdate + (-timezone * 3600), 
				"%I:%M %p");
			endtime = gmstrftime(rssitem.enddate + (-timezone * 3600),
				"%I:%M %p");
			if (view == "day")
			{
				printf("<tr><td width=\"20%\" nowrap bgcolor=\"#DADFEC\" valign=\"top\">");
				printf("<small><b>%s - %s</b></small>&nbsp;</td>",
					starttime, endtime);
				printf("<td width=\"30%\" valign=\"top\">");
			}
			else
			{
				printf("<font size=1 color=#000000>%s</font> ", starttime);
			}

			printf("<a href=\"%s/caledit.asp?path=%s&date=%s&item=%d&view=%s\"><small>%s</small></a><br>",
				home, urlencode(path), thedate, i + 1, urlencode(view),
				txt2html(rssitem.title));

			if (view == "day")
			{
                printf("</td>");
                printf("</td><td width=\"48%\" valign=\"top\">");
                if (sizeof(rssitem.link) > 0)
                {
                    printf("<a href=\"%s\"><font size=1>%s</font></a><br>",
                        rssitem.link, rssitem.link);
                }

                printf("<small>%s</small></td>",
                    rssitem.description ? rssitem.description : "");
				if (updatable) 
				{
                	printf("<td width=\"2%\" valign=\"top\">");
                	printf("<td align=right><a title=\"Remove\" onclick=\"return confirmDelete()\" href=\"%s/modify.asp?path=%s&date=%s&cmd=del&item=%d&view=day\"><img border=0 src=\"/sysimage/icons/delete.gif\"></a></td></tr>",
                   		home, urlencode(path), date, i + 1);
					printf("</td></tr>\n");
				}
				printf("</tr>\n");
			}
		}

		if (view == "day")
			printf("</table>\n");
	}
	else if (view == "day")
	{
		printf("There are no events scheduled for this date.");
	}
}
%>
