<% 
#include "check.asp" 
vcards = NULL;
mvcards = NULL;
try
{
    if (!vcardExists(vcf))
        addrbookImport(vcf);

    vcards = vcardOpen(vcf);

    // Open master "maildir" vcards
    if ((envt("mailserver") == "true") && (envt("havembox") == "true"))
        mvcards = vcardOpen("maildir");
}
catch (e)
{
    write("<!--\n");
    write(exception(e, "info"));
    write("\n-->\n");
}

printEmail(void vcards, void *vcard)
{
    int j = 0;
    int done = 0;
    char *email = null;
    attrs = vcardAttrs(vcards, vcard, "email");
    while ((!done) && (j < sizeof(attrs)))
    {
        attr = attrs[j];
        email = vcardAttrGet(vcards, vcard, attr);
        if ((sizeof(email) > 0) &&
            (vcardParamExists(vcards, vcard, attr, "pref")))
        {
            done = 1;
        }

        j++;
    }


    if (sizeof(email) > 0)
    {
        char *fn = vcardAttrGetValue(vcards, vcard, "fn");
        if (sizeof(fn) > 0)
        {
            trim(fn);
            if ((indexOf(email, '"') == -1) &&
                (indexOf(email, '\'') == -1))
            {
                email = "\"" + fn + "\" " + email;
            }
        }

		printf("<option value='%s'> %s\n", 
			strsubst(email, "'", "\"", 1), txt2html(email));
    }
}
%>
<HTML>
<HEAD>
<TITLE>Contacts</TITLE>
<link rel="stylesheet" href="/sysuser/style.css" type="text/css">
<link rel="stylesheet" href="/sysuser/nav.css" type="text/css">
	<SCRIPT LANGUAGE="JavaScript">
	<!--

	// SET FORM FIELD VALUE TO THE EMAIL ADDRESS SELECTED
	function returnAddr(opt)
	{
	    var list  = "";

	    for (var i=0; i < opt.length; i++)
	    {
		if (opt[i].selected)
		{
		    if (list.length > 0)
			list = list + ", ";

		    list = list + opt[i].value;
		}
	    }

	    if (list.length > 0)
	    {
		if (opener.addrField.value.length > 0)
		    opener.addrField.value = opener.addrField.value + ", " + list;
		else
		    opener.addrField.value = list;
	    }

	    window.close()
	}


	// -->
	</SCRIPT>
</HEAD>
<BODY BGCOLOR="#ffffff" topmargin="0" leftmargin="0" marginheight="0" marginwidt
h="0">

	<CENTER>
	<% if ((vcards != null) || (mvcards != null)) { %>
		<FORM NAME="addrControl" onSubmit="return false;">
		<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0>
		<SELECT MULTIPLE NAME="email" SIZE=12>
 		<%
		list = null;
		if (vcards != null)
			list = vcardList(vcards);
		for (i = 0; i < sizeof(list); i++)
		{
			vcard = list[i];
			printEmail(vcards, vcard);
		}

		list = null;
		if (mvcards != null)
			list = vcardList(mvcards);
		for (i = 0; i < sizeof(list); i++)
		{
			vcard = list[i];
			printEmail(vcards, vcard);
		}
		%>
		</SELECT>
		<br>
		<INPUT TYPE="submit" class="mod" VALUE="Choose" onClick="returnAddr(document.addrControl.email)">
		</TD></TR>
		</TABLE>
		</FORM>
	<% } else { %>
		<I>No address book entries.</I>
	<% } %>
	</CENTER>
</BODY>
</HTML>
