<% 
#include "check.asp" 
area = "contacts";
#include "../header.asp" 
#include "list.asp" 

vcards = NULL;
mvcards = NULL;
try
{
	if (!vcardExists(vcf))
		addrbookImport(vcf);

	vcards = vcardOpen(vcf);

	// Open master "maildir" vcards
	if ((envt("mailserver") == "true") && (envt("havembox") == "true"))
		mvcards = vcardOpen("maildir");
}
catch (e)
{
    write("<!--\n");
    write(exception(e, "info"));
    write("\n-->\n");
}

action = getParameter($params, "action");
guid = getParameter($params, "guid");
if ((vcards != null) && (action == "del"))
{
	guid = getParameter($params, "guid");
	if (guid != null)
	{
		vcardDelete(vcards, guid);
		vcardUpdate(vcards);

        if ((envt("mailserver") == "true") && (envt("havembox") == "true"))
            addrbookExport(vcards);
	}
	printf("<center><div class=\"info\">");
	printf("Contact entry deleted.");
	printf("</div></center>");
}

char *
prefAttr(void *vcards, void *vcard, char *name)
{
	val = null;
	attrs = vcardAttrs(vcards, vcard, name);
	for (j = 0; j < sizeof(attrs); j++)
	{
		attr = attrs[j];
		val = vcardAttrGet(vcards, vcard, attr);
		if ((sizeof(val) > 0) &&
			(vcardParamExists(vcards, vcard, attr, "pref")))
		{
			return val;
		}
	}

	return val;
}

filter = getParameter($params, "filter");
%>
<table border=0 cellpadding=4 cellspacing=4>
<tr valign=top><td nowrap>
<% #include "side.asp" %>
</td><td nowrap width="100%">
    <script language="JavaScript">
    <!--
    function doValidate(theForm)
    {
    	if (theForm.description.value.length > 400)
    	{
       		alert("The description cannot exceed 400 characters\n");
			return false;
    	}
		return true;
	}
	-->
	</script>
	<% err = getParameter($params, "err");
	   if (sizeof(err) > 0) { 
	%>
		<BLOCKQUOTE>
		<div class="error"><B>Error! <%=err;%></B></div>
		</BLOCKQUOTE>
		<BR>
	<% } %>
<% if (vcards == NULL) { %>

	<TABLE border=0 cellspacing=8>
	<TR><TD>
	<I>Your contacts list is not available.  
	Please contact your system administrator.<BR>
	</TD></TR>
	</TABLE>

<% } else { %>

	<% if (vcf != "mbox") { %>
    <table border=0 cellpadding=2 cellspacing=0 width=100%>
    <tr bgcolor=#efefef><td nowrap>&nbsp;Contacts 
	&nbsp;&nbsp;&nbsp;&nbsp;<small>[
	<a href="http://<%=getHostname($request) + userhome;%>/private/contacts.vcf">
	http://<%=getHostname($request) + userhome;%>/private/contacts.vcf</a>
	]</small>
	</td>
    </tr>
    </table>
	<br>
	<% } %>

	<% if ((privs & PRIV_READWRITE) || (vcf == "mbox")) { %>
		<table border=0 cellpadding=2 cellspacing=0 width=100%>
  		<tr><td bgcolor="#DADFEC"> 
		<font face="verdana, arial" size="2" class="text"><b>
		<A HREF="<%=home;%>/contact.asp">Add Contact</A></b></font>
		</td></tr>
		</table>
		<BR>
	<% } %>

    <div id="tabledata">
    <table border=0 cellpadding=2 cellspacing=0 width=100% style="border: 1px solid black">
    <tr bgcolor="#ffff88" id="headerRow">
        <td nowrap style="border:1px solid black; border-width: 0 0 1px 0">
        <a href="javascript:rowSort('1', 1)" title="Sort by Name">
        Name</a></td>
        <td nowrap style="border:1px solid black; border-width: 0 0 1px 0">
        <a href="javascript:rowSort('2', 1)" title="Sort by Email">
        Email</a></td>
        <td nowrap style="border:1px solid black; border-width: 0 0 1px 0">
        <a href="javascript:rowSort('3', 1)" title="Sort by Phone">
        Phone</a></td>
        <td width=90% style="border:1px solid black; border-width: 0 0 1px 0">
		&nbsp;&nbsp;&nbsp;
		<% if ((privs & PRIV_READWRITE) || (vcf == "mbox")) { %>
			Remove
		<% } %>
		</td>
    </tr>

<%
	try
	{
		total = 0;
		list = vcardList(vcards);
		readwrite = 0;
		if ((privs & PRIV_READWRITE) || (vcf == "mbox"))
			readwrite = 1;
		total = listContacts(list, total, readwrite);

		if (mvcards != null)
		{
			mlist = vcardList(mvcards);
			if (sizeof(mlist) > 0)
			{
				printf("<tr><td colspan=4><hr></td></tr>");
				total = listContacts(mlist, total, 0);
			}
		}
	}
    catch (e)
    {
        write("<!--\n");
        write(exception(e, "info"));
        write("\n-->\n");
        printf("<BR><B>" + exception(e, "message") + "</B><BR>");
    }

	if (total == 0)
		printf("<tr><td colspan=4><I>No contacts found.</I></td></tr>");

	printf("</table></div>");
} 
%>
	<br>

	<script language="JavaScript">
	<!--
	function addrValidate(theForm)
	{
		var validName = true;
		var email1 = trim(theForm.email1.value);
		var regx = /^[A-Za-z0-9\@\+=%\\'\?\^!\$(\);\"&]+[\w\.\@\+=%\\'\?\^!\$(\);\"&-_]*@[A-Za-z0-9\@\+=%\\'\?\^!\$\(\);\"&]+[\w\.\@\+=%\\'\?\^!\$\(\);\"&-]*\.[\w\.\@\+=%\\'\?\^!\$\(\);\"&-]+$/;

		if ((theForm.firstname.value == "") &&
			(theForm.lastname.value == "") &&
			(theForm.nickname.value == "") &&
			(email1 == ""))
		{
			theForm.firstname.focus();
			validName = false;
		}

		if (validName == false)
		{
			alert("You must enter either a first name, last name, nickname or an email address for this contact.");
			return false;
		}

		// Verify the email addresses are valid
		if (email1 != "")
		{
			if(!isValidEmailAddress(email1, regx)) {
				alert(theForm.email1.value + " is an invalid address. Valid values are A-Z a-z 0-9 . _ - @ + = % ' ? ^ ! $ ( ) ; \" &");
				return false;
			}
		}

		return true;
	}
	// -->
	</SCRIPT>

</td></tr></table>
<br>
<% #include "../footer.asp" %>
