<% 
#include "check.asp" 

area = "account";
#include "../header.asp" 

try
{
	action = getParameter($params, "action");
	if ((path != null) && (action == "delete"))
	{
		username = getParameter($params, "username");
		if (sizeof(username) > 0)
		{
			passwddelete(path, username);
			printf("<center><div class=\"info\">");
			printf("Friend '%s' has been removed.<br>", username);
			printf("</div></center>");
		}
	}
	else if ((path != null) && (action == "create"))
	{
		username = getParameter($params, "username");
		if (sizeof(username) > 0)
		{
			password = getParameter($params, "password");
			privs = (int)getParameter($params, "privs");
			alist = getParameters($params, "access");
			access = 0;
			for (i = 0; i < sizeof(alist); i++)
				access |= (int)alist[i];

			char *davdir = null;
			if (envt("userdir") == "true")
			{
				davdir = getUserPath($request, "/~" + envt("username") + 
					"/private");
			}
			else
			{
				davdir = getUserPath($request, "/private");
			}

			davdir += "/.DAV";
			if (!isDir(davdir))
				mkdir(davdir);

			if (passwdload(path, username) == null)
			{
				passwdadd(path, username, password, "other", username, "/",
					privs, 0, access);
				printf("<center><div class=\"info\">");
				printf("Friend '%s' has been added.", username);
				printf("</div></center>");
			}
			else
			{
				printf("<center><div class=\"error\">");
				printf("Friend '%s' already exists.", username);
				printf("</div></center>");
			}
		}
	}
	else if ((path != null) && (action == "update"))
	{
		username = getParameter($params, "username");
		if (sizeof(username) > 0)
		{
			password = getParameter($params, "password");
			privs = (int)getParameter($params, "privs");
			alist = getParameters($params, "access");
			access = 0;
			for (i = 0; i < sizeof(alist); i++)
				access |= (int)alist[i];
	
			passwddelete(path, username);
			passwdadd(path, username, password, "other", username, "/",
				privs, 0, access);
			printf("<center><div class=\"info\">");
			printf("Friend '%s' has been updated.", username);
			printf("</div></center>");
		}
	}
}
catch (e)
{
	printf("<center><div class=\"error\">");
	printf("Friend '%s' could not be modified, please contact the system administrator.", username);
	printf("</div></center>");

	write("<!--\n");
	write(exception(e, "info"));
	write("\n-->\n");
}

showUsers(char *path, char **users)
{
	printf("<table border=0 cellspacing=4>\n");
	printf("<tr><td>&nbsp;</td><td><B>Friend</b>&nbsp;&nbsp;</td>");
	printf("<td><b>Privileges</b>&nbsp;&nbsp;&nbsp;&nbsp;</td>");
	printf("<td><b>Access</b></td></tr>\n");

	for (i = 0; i < sizeof(users); i++) 
	{
		user = passwdload(path, users[i]);

		printf("<tr><td>");
		printf("<a href=\"%s/index.asp?action=delete&username=%s\" onclick=\"return confirmDelete()\">\n",
			home, txt2html(user.username));
		printf("<IMG border=0 HEIGHT=20 WIDTH=20 ALT=\"Delete User\" SRC=\"/sysimage/icons/delete.gif\"></A>\n");

		printf("</td><td nowrap>");

		printf("<A HREF=\"%s/upduser.asp?username=%s\">%s</a>",
			home, txt2html(user.username), user.username);

		printf("</td><td nowrap><small>");

		if (user.privs == PRIV_READONLY)
			printf("Read Only");
		else if (user.privs == PRIV_READWRITE)
			printf("Read/Write");
		else 
			printf("Unknown");

		printf("</small>&nbsp;&nbsp;&nbsp;</td><td nowrap><small>");

		if (user.access & ACCESS_DOCMGR)
			printf("Document Manager ");
		if (user.access & ACCESS_MAIL)
			printf("Mail ");
		if (user.access & ACCESS_BLOG)
			printf("Blog ");
		if (user.access & ACCESS_PHOTOS)
			printf("Photos ");
		if (user.access & ACCESS_CALENDAR)
			printf("Calendar ");
		if (user.access & ACCESS_CONTACTS)
			printf("Contacts ");
		if (user.access & ACCESS_TASKS)
			printf("Tasks ");
		if (user.access & ACCESS_FORUM)
			printf("Forum ");
		if (user.access & ACCESS_FEEDS)
			printf("Feeds ");

		printf("</small></td></tr>\n");
	}

	printf("</table>\n");
}
%>
<table border=0 cellpadding=4 cellspacing=4>
<tr valign=top><td nowrap>
<% #include "side.asp" %>
</td><td nowrap width="100%">
    <script language="JavaScript">
    <!--
	var inValid = "~:|/ "
    function doValidate(theForm)
    {
		if (theForm.username.value == "")
		{
			alert("Please enter a value for the \"Friend\" name.");
			theForm.username.focus();
			return (false);
		}
    	for (j = 0; j < theForm.username.value.length; j++)
    	{
        	if (inValid.indexOf(theForm.username.value.charAt(j)) != -1)
        	{
            	alert("The \"Username\" contains invalid characters (:| )");
            	theForm.username.focus();
            	return (false);
        	}
    	}
		return true;
	}
    function confirmDelete()
    {
    	return confirm("Remove all friend access?");
	}
	-->
	</script>
	<% err = getParameter($params, "err");
	   if (sizeof(err) > 0) { 
	%>
		<BLOCKQUOTE>
		<div class="error"><B>Error! <%=err;%></B></div>
		</BLOCKQUOTE>
		<BR>
	<% } %>

	<% if (path == NULL) { %>
    	<table border=0 cellpadding=2 cellspacing=0 width=100%>
    	<tr bgcolor=#efefef><td nowrap>&nbsp;<B>The friends feature is 
		not available for your account.</B></td></tr></table>
	<% } else { %>
		<% 
		users = null;
		if (isFile(path))
			users = passwdusers(path);
		%>
		<div id="m_2" class="ebox" style="position:relative">
    	<table border=0 cellpadding=2 cellspacing=0 width=100%>
    	<tr bgcolor=#efefef><td nowrap>&nbsp;<B>
		<% if (sizeof(users) == 0) { %>
			No friends have been granted access.
		<% } else if (sizeof(users) == 1) { %>
			1 friend has been granted access.
		<% } else { %>
			<%=sizeof(users);%> friends have been granted access.
		<% } %>
		</B></td>
		<td align=right><a href="#" class=el onclick="return edit(2);">
		<font size=-1>add friend</font></a>
		<a href="#" class=csl onclick="return cedit(2);"><font size=-1>close add</font></a></td>
		</tr>

		<tr class=es><td colspan=2>

			<FORM METHOD="POST" ACTION="<%=home;%>/index.asp" onsubmit="return doValidate(this)">
			<INPUT TYPE="hidden" NAME="action" VALUE="create">
			<TABLE border=0 cellpadding=2 cellspacing=2>
			<TR valign=top>
			<TD align=right nowrap><B>Friend</B></TD>
			<TD colspan=3><INPUT TYPE="text" NAME="username" VALUE="" SIZE=20 MAXLENGTH=40>
			</TD>
			</TR>
			<TR VALIGN=top>
			<TD align=right nowrap><B>Password</B></TD>
			<TD colspan=3><INPUT TYPE="password" NAME="password" VALUE="" SIZE=20 MAXLENGTH=40></TD>
			</TR>
			<TR VALIGN=top>
			<TD align=right nowrap><B>Access</B></TD>
			<TD>
			<INPUT TYPE="radio" NAME="privs" VALUE="1" CHECKED> Read Only<BR>
			<INPUT TYPE="radio" NAME="privs" VALUE="2"> Read/Write<BR>
			</TD>
			<TD nowrap>&nbsp;&nbsp;&nbsp;<B>Services</B></TD>
			<TD>
			<INPUT TYPE="checkbox" NAME="access" VALUE="<%=ACCESS_BLOG;%>" CHECKED> Blog<BR>
			<INPUT TYPE="checkbox" NAME="access" VALUE="<%=ACCESS_CALENDAR;%>" CHECKED> Calendar<BR>
			<INPUT TYPE="checkbox" NAME="access" VALUE="<%=ACCESS_CONTACTS;%>" CHECKED> Contacts<BR>
			<INPUT TYPE="checkbox" NAME="access" VALUE="<%=ACCESS_DOCMGR;%>" CHECKED> Document Manager<BR>
			<INPUT TYPE="checkbox" NAME="access" VALUE="<%=ACCESS_FEEDS;%>" CHECKED> Feeds<BR>
			<INPUT TYPE="checkbox" NAME="access" VALUE="<%=ACCESS_FORUM;%>" CHECKED> Forum<BR>
			<INPUT TYPE="checkbox" NAME="access" VALUE="<%=ACCESS_MAIL;%>" CHECKED> Mail<BR>
			<INPUT TYPE="checkbox" NAME="access" VALUE="<%=ACCESS_PHOTOS;%>" CHECKED> Photos<BR>
			<INPUT TYPE="checkbox" NAME="access" VALUE="<%=ACCESS_TASKS;%>" CHECKED> Tasks<BR>
			</TD>
			<TR>
			<TD></TD><TD colspan=3><INPUT TYPE="submit" class="mod" VALUE="Grant Friend Access"></TD>
			</TR>
			</TABLE>
			</FORM>
		</td></tr></table>
		</div>

		<%
		if (sizeof(users) > 0)
		{
			sort(users);
			showUsers(path, users);
		}
		else
		{
			printf("<script>\nedit(2);\n</script>\n");
		}
		%>
	<% } %>

	<br>
	<br>
	<small>Note: Any friends granted access to your account
	will appear to the administrator <br>
	under your login and be subject to the same restrictions 
	as your account.
	</small>
</td></tr></table>
<br>
<% #include "../footer.asp" %>
