<% 
// Require an authenticated user to access this page.
if (authUser() != 0)
	exit;

access = getAccess($request);
if (!(access & ACCESS_MAIL))
{
%>
	<BODY bgColor=#ffffff>
	<B>Internet mail is not available to this account!</B>
	</BODY>
	</HTML>
<%
	exit; 
}

if ((sizeof(vhostProperty(envt("vhost"), "imailimap")) == 0) ||
    (sizeof(vhostProperty(envt("vhost"), "imailsmtp")) == 0))
{
%>
	<BODY bgColor=#ffffff>
	<B>Internet mail servers (IMAP and/or SMTP) are not configured!</B>
	</BODY>
	</HTML>
<%
	exit; 
}

if (envt("username") == "anonymous")
{
%>
	<BODY bgColor=#ffffff>
	<B>User anonymous not permitted access to mail.</B>
	</BODY>
	</HTML>
<%
	exit; 
}

char *home = "/sysuser/imail";

char *imailu = getState($request, "imailu");
if (sizeof(imailu) <= 0)
{
	imailu = getProfile($request, "imailu");
	if (sizeof(imailu) > 0)
	{
		setState($request, "imailu", imailu);
	}
}


imap = imapSession();
if (imap == NULL)
{
	try
	{
		char *imailp = getState($request, "imailp");
		if (sizeof(imailp) <= 0)
		{
			imailp = getProfile($request, "imailp");
			if (sizeof(imailp) > 0)
			{
				setState($request, "imailp", imailp);
			}
			else
			{
				imailu = NULL;
			}
		}

		if (sizeof(imailu) > 0)
		{
			imap = imapConnectAs(vhostProperty(envt("vhost"), 
				"imailimap"), imailu, 
				aesdecrypt(imailu, imailp));
		}
		else
		{
			imap = imapConnect(vhostProperty(envt("vhost"), 
				"imailimap"));
		}
	}
	catch (e)
	{
		msg = exception(e, "message");
		if ((msg != NULL) && (strnicmp(msg, "IMAP Login Error", 16) == 0))
		{
			sendRedirect($response, home + "/login.asp");
			exit;
		}

		write("\n<!--\n");
		write(exception(e, "info"));
		write("\n-->\n");

		if (sizeof(imailu) <= 0)
			imailu = envt("username");
%>
		<BODY bgColor=#ffffff>
		<B>User <%=imailu;%> IMAP server 
		(<%=vhostProperty(envt("vhost"), "imailimap");%>) 
		is unavailable.</B><BR><BR><%=msg;%>
		</BODY>
		</HTML>
<%
		exit;
	}
}

char *start = findParameter($params, "start", "1");

char *sort = getState($request, "sort");
if (sizeof(sort) <= 0)
{
    sort = findParameter($params, "sort", "desc");
    setState($request, "sort", sort);
}
else if (sizeof(getParameter($params, "sort")) > 0)
{
    sort = getParameter($params, "sort");
    setState($request, "sort", sort);
}

char *folder = getState($request, "folder");
if (sizeof(folder) <= 0)
{
	folder = findParameter($params, "folder", "inbox");
	setState($request, "folder", folder);
}
else if (sizeof(getParameter($params, "folder")) > 0)
{
	folder = getParameter($params, "folder");
	setState($request, "folder", folder);
}

char *preview = getState($request, "preview");
if (sizeof(preview) <= 0)
{
	preview = findParameter($params, "preview", "false");
	setState($request, "preview", preview);
}
else if (sizeof(getParameter($params, "preview")) > 0)
{
	preview = getParameter($params, "preview");
	setState($request, "preview", preview);
}

char *count = getState($request, "count");
if (sizeof(count) <= 0)
{
	count = getProfile($request, "count");
	if (((int)count <= 0) || ((int)count > 100))
		count = "25";
	setState($request, "count", count);
}
else if (((int)count <= 0) || ((int)count > 100))
{
	count = "25";
	setState($request, "count", count);
}

char *wrap = getState($request, "wrap");
if (sizeof(wrap) <= 0)
{
	wrap = getProfile($request, "wrap");
	if (sizeof(wrap) == 0)
		wrap = "0";
	else if ((int)wrap < 0)
		wrap = "72";
	setState($request, "wrap", wrap);
}
else if (((int)wrap < 0) || ((int)wrap > 200))
{
	wrap = "72";
	setState($request, "wrap", wrap);
}

char *wrap_out = getState($request, "wrap_out");
if (sizeof(wrap_out) <= 0)
{
	wrap_out = getProfile($request, "wrap_out");
	if ((int)wrap_out <= 0)
		wrap_out = "0";
	setState($request, "wrap_out", wrap_out);
}

char *style = getState($request, "style");
if (sizeof(style) <= 0)
{
	style = getProfile($request, "style");
	if (sizeof(style) <= 0)
		style = "txtconvert";
	setState($request, "style", style);
}

char *prefertext = getState($request, "prefertext");
if (sizeof(prefertext) <= 0)
{
	prefertext = getProfile($request, "prefertext");
	if (sizeof(prefertext) <= 0)
		prefertext = "true";
	setState($request, "prefertext", prefertext);
}

char *shortFolderName(char *folderName)
{
	int tail = strlen(folderName) - 1;
	while ((tail > 0) && (folderName[tail - 1] != '.'))
		tail--;

	return &folderName[tail];
}
%>
