<%
#include "check.asp"
area = "imail";
#include "../header.asp"
%>

<%
char *info = NULL;
char *error = NULL;
try
{
	char *action = getParameter($params, "action");
	if (action == "truncate")
	{
		char *name = getParameter($params, "name");
		if (sizeof(name) > 0)
		{
			imapFolderTruncate(imap, name);
			sprintf(info, "Folder '%s' truncated.", name);
		}
	}
	else if (action == "create")
	{
		char *name = getParameter($params, "name");
		if (sizeof(name) > 0)
		{
			imapFolderCreate(imap, name);
			sprintf(info, "Folder '%s' created.", name);
		}
	}
	else if (action == "delete")
	{
		char *name = getParameter($params, "name");
		if (sizeof(name) > 0)
		{
			imapFolderDelete(imap, name);
			sprintf(info, "Folder '%s' deleted.", name);
		}
	}
	else if (action == "rename")
	{
		char *name = getParameter($params, "name");
		char *newname = getParameter($params, "newname");
		if ((sizeof(name) > 0) && (sizeof(newname) > 0))
		{
			imapFolderRename(imap, name, newname);
			sprintf(info, "Folder '%s' renamed to '%s'.", name, newname);
		}
	}
}
catch (e)
{
	error = exception(e, "message");
	write("<!--\n");
	write(exception(e, "info"));
	write("\n-->\n");
}

int quota = imapQuota(imap);
int used = imapQuotaUsed(imap);
int capacity = 0;
if (quota > 0)
	capacity = (int)(100 * ((float)(used) / quota));
%>
<table border=0 cellpadding=4 cellspacing=4>
<tr valign=top><td nowrap>
<% #include "side.asp" %>
</td><td nowrap width="100%">
	<SCRIPT language="JavaScript">
	<!--
	function confirmDelete()
	{
		return confirm("Delete selected folder?");
	}
	function confirmTruncate()
	{
		return confirm("Delete all messages from the selected folder?");
	}
	//-->
	</SCRIPT>

<%
	if (info != NULL)
		printf("<div class=\"info\">%s</div>\n", info);

	if (error != NULL)
		printf("<div class=\"error\">%s</div>\n", error);
%>

	<table border=0 width=100% bgcolor=#efefef cellpadding=4 cellspacing=0>
	<tr><td class=mboxhead>Manage Folders</td></tr>
	</table>
	<table border=0 cellpadding=4>
	<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Capacity</td>
	<td>
	<div style="width: 100px; border: 1px solid black; height: 10px">
	<div style="position: relative; width: <%=capacity;%>%; height: 10px;
		background-color: #00FF00; top: 0px; left: 0px"></div>
	</div>
	</td><td>
    <B><%=capacity;%>% of <%=getSizeK(quota);%></B>
	</td></tr>
	</table>
	<TABLE WIDTH=100% border=0 cellspacing=4>
	<TR><TD valign="top">
		<TABLE border=0 cellpadding=4 cellspacing=0>
		<TR bgcolor=#003366>
		<TD class=mboxhead align=left>&nbsp;</TD>
		<TD class=mboxhead align=left>Folder&nbsp;&nbsp;&nbsp;</TD>
		<TD class=mboxhead align=left>&nbsp;</TD>
		</TR>
		<%
		folders = imapFolders(imap);
		for (i = 0; i < sizeof(folders); i++)
		{
        	printf("<tr><td>");

    		// Exclude current folder from pick-list
    		if (strcasecmp(folders[i], "inbox") != 0)
			{
                printf("<A HREF=\"%s/folders.asp?action=delete&name=%s\" onClick=\"return confirmDelete()\"><IMG border=0 height=18 width=16 SRC=\"/sysimage/icons/delete.gif\">Delete</A>\n",
                    home, folders[i]);
			}

        	printf("</td>");
       		printf("</td><td><b>%s</b></td><td>\n", 
				shortFolderName(folders[i]));
    		if (strcasecmp(folders[i], "inbox") != 0)
			{
                printf("[<A HREF=\"%s/frename.asp?name=%s\">rename</a>] ",
                    home, folders[i]);
			}

            printf("[<A HREF=\"%s/folders.asp?action=truncate&name=%s\" onClick=\"return confirmTruncate()\">delete all messages</A>]</td></tr>\n",
				home, folders[i]);
		}
		%>
		</TABLE>
		<BR>
		<HR>
		<BR>
		<B><I>Add a New Folder...</I></B>
		<FORM METHOD=POST ACTION="<%=home;%>/folders.asp">
		<INPUT TYPE=hidden NAME=action VALUE="create">
		<INPUT TYPE=TEXT NAME="name" VALUE="newfolder" size=20 
			maxlength=64>
		<INPUT TYPE=submit class="mod" VALUE="Create Folder">
		</FORM>
		<i>Note: <small>Folder names may contain only ASCII 
		characters.</small></i>
	</TD>
	</TR>
	</TABLE>
</td></tr></table>
<br>
<% #include "../footer.asp" %>
