<%
// Require an authenticated user to access this page.
if (authUser() != 0)
	exit;

access = getAccess($request);
if ((envt("webdav") != "true") || !(access & ACCESS_FEEDS))
{
%>
	<BODY bgColor=#ffffff>
	<B>Feed Manager is not enabled for this account!</B>
	</BODY>
	</HTML>
<%
	exit; 
}

path = "/";

char *rssfile = findParameter($params, "rss", "/private/favorites.rss"); 
if ((rssfile != "/private/favorites.rss") && (rssfile != "/private/mysite.rss"))
	rssfile = "/private/favorites.rss";

char *cmd = getParameter($params, "cmd"); 
int item = (int)findParameter($params, "item", "0"); 

filename = buildpath(path, rssfile);
host = getHostname($request);
url = "http://" + host;
if (envt("userdir") == "true")
	url = url + "/~" + envt("username");
else
	url = url + envt("userhome");

int updatable = docmgrUpdatable(path, rssfile);

if (updatable)
{
	// Grab the RSS feed
	rss = NULL;
	char *rsspath = getUserPath($request, filename);
    try
    {
		xmlfav = XMLOpen(rsspath, 0);
		if (xmlfav != NULL)
		{
			rss = RSS(xmlfav);
			XMLFree(xmlfav);
		}
	}
   	catch (e)
   	{
   		// Ignore feed failres, just message below.
		write("<!--\n");
		write(exception(e, "info"));
		write("\n-->\n");
  	}

	if ((cmd == "del") && 
		(rss != NULL) && 
		(item > 0) &&
		(item <= sizeof(rss.items)))
	{
		rss.items[item - 1] = NULL;
		RSSSave(rss, rsspath);
	}
	else if ((cmd == "add") && (sizeof(getParameter($params, "link")) > 0))
	{
		if (rss == NULL)
		{
    		struct RSS myrss;
			myrss.title = "My RSS";
			myrss.link = url + filename;
    		rss = myrss;
		}

		struct RSSITEM myitem;
		
		if (sizeof(getParameter($params, "title")) > 0)
			myitem.title = getParameter($params, "title");
		else
			myitem.title = "RSS Feed";
		myitem.link = getParameter($params, "link");
		myitem.description = NULL;
		myitem.author = envt("username");
		myitem.pubDate = NULL;

		if (sizeof(rss.items) == 0)
			rss.items[] = { myitem };
		else
			rss.items[sizeof(rss.items)] = myitem;
		RSSSave(rss, rsspath);
	}
}

sendRedirect($response, "/sysuser/index.asp");
